<template>
  <q-btn
    :color="btnColor"
    :text-color="textColor"
    :ripple="false"
    class="box col flex-center"
    @click="clicked()"
  ><span class="text-h5">{{displayValue}}</span></q-btn>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'

export default {
  props: [
    'boxRow',
    'boxCol',
    'row',
    'col'
  ],
  data () {
    return {
      index: undefined,
      selected: false,
      btnColor: 'accent',
      textColor: 'primary'
    }
  },
  computed: {
    ...mapGetters('grid', ['grid', 'editIndex', 'solvable']),
    displayValue () {
      return this.grid[this.index].Number === 0 ? '' : this.grid[this.index].Number
    }
  },
  methods: {
    ...mapActions('grid', ['changeEditIndex', 'checkBox']),
    clicked () {
      console.log('index', this.index)
      if (!this.selected) {
        this.changeEditIndex(this.index)
        this.$root.$emit('reset')
        this.selected = true
        this.btnColor = 'info'
        this.textColor = 'primary'
      } else {
        this.changeEditIndex(-1)
        this.renderButtonDefault()
        this.selected = false
      }
    },
    renderButtonDefault () {
      this.textColor = 'primary'
      if (this.boxRow === 1 && this.boxCol === 2) {
        this.btnColor = 'positive'
      } else if (this.boxRow === 2 && this.boxCol !== 2) {
        this.btnColor = 'positive'
      } else if (this.boxRow === 3 && this.boxCol === 2) {
        this.btnColor = 'positive'
      } else { this.btnColor = 'white' }
    }
  },
  created () {
    const e = this.grid.find(e =>
      e.BoxRow === this.boxRow &&
      e.BoxCol === this.boxCol &&
      e.Row === this.row &&
      e.Col === this.col
    )
    this.value = e.Number
    this.index = e.Index
    this.renderButtonDefault()
  },
  mounted () {
    this.$root.$on('reset', () => {
      if (this.editIndex !== this.index) {
        this.renderButtonDefault()
        this.selected = false
      }
    })
  }
}
</script>
